﻿using Rs.Motion.Base.Config;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Rs.Motion.Base
{
    public class ICard
    {
		public Dictionary<ushort,IAxis> AxisIdDic= new Dictionary<ushort,IAxis>();
		public Dictionary<string,IAxis> AxisNameDic= new Dictionary<string,IAxis>();

		private CardConfig _Config;

		public CardConfig Config
        {
			get { return _Config; }
			set { _Config = value; }
		}

		public virtual ErrorCode Init()
		{
			return ErrorCode.Ok;
		}

        public virtual ErrorCode Save()
        {
            return ErrorCode.Ok;
        }

        public  virtual IAxis GetAxis(ushort axisID)
        {
            if (AxisIdDic.ContainsKey(axisID)) return AxisIdDic[axisID];
            return null;
        }

        public virtual IAxis GetAxis(string axisName)
        {
            if (AxisNameDic.ContainsKey(axisName)) return AxisNameDic[axisName];
            return null;
        }
    }
}
