﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Rs.Motion.Base
{
    public class ICardManager
    {
        /// <summary>
        /// 卡是否初始化
        /// </summary>
        public bool IsInitialized { get; set; }
        /// <summary>
        /// 同类型的卡，不管有几张卡，统一在这里初始化
        /// </summary>
        /// <returns></returns>
        public virtual ErrorCode Init()
        {
            return ErrorCode.Ok;
        }

        /// <summary>
        /// 添加一张IO卡
        /// </summary>
        /// <returns></returns>
        public virtual IIOCard AddIoCard(int cardID, string name, string vender, bool isEthercat, ushort inNum, ushort outNum, int slaveID)
        {
            return null;
        }
    }
}
