﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Rs.Motion
{
    public enum ErrorCode
    {
        /// <summary>
        /// 成功
        /// </summary>
        Ok,
        /// <summary>
        /// 未知的失败
        /// </summary>
        Fail,
        /// <summary>
        /// 卡不存在
        /// </summary>
        CardNotExist,
        /// <summary>
        /// 卡未初始化
        /// </summary>
        CardNotInit,
        /// <summary>
        /// 卡初始化失败
        /// </summary>
        CardInitFail,
        /// <summary>
        /// 加载配置文件失败
        /// </summary>
        CardLoadConfigFail,
        /// <summary>
        /// 卡已经就绪
        /// </summary>
        CardAlready,
        /// <summary>
        /// 轴未初始化
        /// </summary>
        AxisNotInit,
        /// <summary>
        /// 轴初始化失败
        /// </summary>
        AxisInitFail,
        /// <summary>
        /// 轴未回原
        /// </summary>
        AxisNotHome,
        /// <summary>
        /// 轴移动失败
        /// </summary>
        AxisMoveFail,
        /// <summary>
        /// 未定义一圈需要运动的距离
        /// </summary>
        UndefineDistanceOneRound,
        /// <summary>
        /// 未定义转一圈需要多少脉冲
        /// </summary>
        UndefinePulseOneRound,
        /// <summary>
        /// 急停信号
        /// </summary>
        Emergency,
        /// <summary>
        /// 报警
        /// </summary>
        Alarm,
        /// <summary>
        /// 未使能
        /// </summary>
        ServoOff,
        /// <summary>
        /// 运动中
        /// </summary>
        Moving,
        /// <summary>
        /// 不安全
        /// </summary>
        Unsafe,
        /// <summary>
        /// 超出限位
        /// </summary>
        OutOfLimit
    }
}
