﻿using Rs.Controls;
using Rs.DataAccess;
using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Rs.Framework
{
    public static class GlobalVar
    {

        /// <summary>
        /// 当前配方
        /// </summary>
        public static string CurRecipe
        {
            get
            {
                return SysConfigParam.GetValue<string>(nameof(CurRecipe));
            }
        }

        public static int WholeSpeed
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(WholeSpeed));
            }
        }

        public static int WholeVacWaitTime
        {
            get {
                //return SysConfigParam.GetValue<int>(nameof(WholeVacWaitTime));
                return 1000;
            }
        }

        /// <summary>
        /// 飞拍速度
        /// </summary>
        public static int FlyCameraSpeed
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(FlyCameraSpeed));
            }
        }

        /// <summary>
        /// 搬运速度
        /// </summary>
        public static int TakeTraySpeed
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(TakeTraySpeed));
            }
        }

        /// <summary>
        /// 上相机名称
        /// </summary>
        public static string UpCameraName
        {
            get
            {
                return SysConfigParam.GetValue<string>(nameof(UpCameraName));
            }
        }

        /// <summary>
        /// 下相机名称
        /// </summary>
        public static string DownLocationCameraName
        {
            get
            {
                return SysConfigParam.GetValue<string>(nameof(DownLocationCameraName));
            }
        }

        /// <summary>
        /// 下扫码相机名称
        /// </summary>
        public static string DownScanCameraName
        {
            get
            {
                return SysConfigParam.GetValue<string>(nameof(DownScanCameraName));
            }
        }
        /// <summary>
        /// 空跑模式
        /// </summary>
        public static bool RunSpace
        {
            get
            {
                return SysConfigParam.GetValue<bool>(nameof(RunSpace));
            }
        }

        /// <summary>
        /// 下定位相机像素当量
        /// </summary>
        public static double DownCameraMmPerPixel
        {
            get
            {
                return SysConfigParam.GetValue<double>(nameof(DownCameraMmPerPixel));
            }
        }
        /// <summary>
        /// 破真空偏移高度
        /// </summary>
        public static double CloseVacOffsetHeight
        {
            get
            {
                return SysConfigParam.GetValue<double>(nameof(CloseVacOffsetHeight));
            }
        }

        /// <summary>
        /// 轴运动到位后等待时间
        /// </summary>
        public static int AxisArrivedWaittime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(AxisArrivedWaittime));
            }
        }
        /// <summary>
        /// Tray盘放料时相对于取料位的偏移高度
        /// </summary>
        public static double TrayDumpOffsetHeight
        {
            get
            {
                return SysConfigParam.GetValue<double>(nameof(TrayDumpOffsetHeight));
            }
        }

        /// <summary>
        /// Tray盘放料时破真空时间
        /// </summary>
        public static int TrayDumpCloseVacTime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(TrayDumpCloseVacTime));
            }
        }

        #region 排料吸头
        /// <summary>
        /// 排料吸头开真空吸延时 
        /// </summary>
        public static int LoadNozzleOpenVacSuctionDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(LoadNozzleOpenVacSuctionDelaytime));
            }

        }
        /// <summary>
        /// 排料吸头关真空吸延时
        /// </summary>
        public static int LoadNozzleCloseVacSuctionDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(LoadNozzleCloseVacSuctionDelaytime));
            }
        }
        /// <summary>
        /// 排料吸头开真空破延时
        /// </summary>
        public static int LoadNozzleOpenVacBreakDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(LoadNozzleOpenVacBreakDelaytime));
            }
        }
        /// <summary>
        /// 排料吸头关真空破延时
        /// </summary>
        public static int LoadNozzleCloseVacBreakDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(LoadNozzleCloseVacBreakDelaytime));
            }
        }

        #endregion

        #region 周转盘真空
        /// <summary>
        /// 周转盘开真空吸延时
        /// </summary>
        public static int TurnoverTrayOpenVacSuctionDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(TurnoverTrayOpenVacSuctionDelaytime));
            }
        }
        /// <summary>
        /// 周转盘关真空吸延时
        /// </summary>
        public static int TurnoverTrayCloseVacSuctionDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(TurnoverTrayCloseVacSuctionDelaytime));
            }
        }
        /// <summary>
        /// 周转盘开真空破延时
        /// </summary>
        public static int TurnoverTrayOpenVacBreakDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(TurnoverTrayOpenVacBreakDelaytime));
            }
        }
        /// <summary>
        /// 周转盘关真空破延时
        /// </summary>
        public static int TurnoverTrayCloseVacBreakDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(TurnoverTrayCloseVacBreakDelaytime));
            }
        }
        #endregion

        #region 周转吸头真空
        /// <summary>
        /// 周转吸头开真空吸延时
        /// </summary>
        public static int TurnoverNozzleOpenVacSuctionDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(TurnoverNozzleOpenVacSuctionDelaytime));
            }
        }
        /// <summary>
        /// 周转吸头关真空吸延时
        /// </summary>
        public static int TurnoverNozzleCloseVacSuctionDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(TurnoverNozzleCloseVacSuctionDelaytime));
            }
        }
        /// <summary>
        /// 周转吸头开真空破延时
        /// </summary>
        public static int TurnoverNozzleOpenVacBreakDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(TurnoverNozzleOpenVacBreakDelaytime));
            }
        }
        /// <summary>
        /// 周转吸头关真空破延时
        /// </summary>
        public static int TurnoverNozzleCloseVacBreakDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(TurnoverNozzleCloseVacBreakDelaytime));
            }
        }
        #endregion

        #region 保压真空
        /// <summary>
        /// 保压开真空吸延时
        /// </summary>
        public static int PressOpenVacSuctionDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(PressOpenVacSuctionDelaytime));
            }
        }
        /// <summary>
        /// 保压关真空吸延时
        /// </summary>
        public static int PresseCloseVacSuctionDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(PresseCloseVacSuctionDelaytime));
            }
        }
        /// <summary>
        /// 保压开真空破延时
        /// </summary>
        public static int PresseOpenVacBreakDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(PresseOpenVacBreakDelaytime));
            }
        }
        /// <summary>
        /// 保压关真空破延时
        /// </summary>
        public static int PressCloseVacBreakDelaytime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(PressCloseVacBreakDelaytime));
            }
        }
        #endregion


        /// <summary>
        /// 飞拍曝光时间
        /// </summary>
        public static int FlyGrabExposureTime
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(FlyGrabExposureTime));
            }
        }

        /// <summary>
        /// 飞拍增益
        /// </summary>
        public static int FlyGrabGain
        {
            get
            {
                return SysConfigParam.GetValue<int>(nameof(FlyGrabGain));
            }
        }
    }
}
