﻿using Rs.Controls;
using Rs.MotionPlat.SysConfig;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Rs.MotionPlat
{
    public partial class ConfigForm : BaseForm
    {
        public ConfigForm()
        {
            InitializeComponent();
        }

        protected void Menu_Click(object sender, EventArgs e)
        {
            btnIO.Selected = false;
            btnMotor.Selected = false;
            btnUpCameraCalibration.Selected = false;
            btnOldTest.Selected = false;
            btnNozzleDistance.Selected = false;
            btnDownCameraCalibration.Selected = false;
            btnUpCameraAndClampCalibration.Selected = false;
            ButtonEx button = (ButtonEx)sender;
            if (button == btnMotor)
            {
                //CloseWin(panelMain.Controls);
                panelMain.Controls.Clear();
                btnMotor.Selected = true;
                BaseForm form;
                if (ActiveForms.Get("MonitorConfig") == null)
                {
                    form = new MonitorConfig();
                    form.Name = "MonitorConfig";
                    form.Dock = DockStyle.Fill;
                    form.TopLevel = false;
                    form.Visible = true;
                    ActiveForms.Add(form);
                }
                else
                {
                    form = ActiveForms.Get("MonitorConfig");
                    form.Visible= true;
                }
                panelMain.Controls.Add(form);
            }
            else if(button== btnOldTest)
            {
                //CloseWin(panelMain.Controls);
                panelMain.Controls.Clear();
                btnOldTest.Selected = true;
                BaseForm form;
                if (ActiveForms.Get("OldTest") == null)
                {
                    form = new OldTest();
                    form.Name = "OldTest";
                    form.Dock = DockStyle.Fill;
                    form.TopLevel = false;
                    form.Visible = true;
                    ActiveForms.Add(form);
                }
                else
                {
                    form = ActiveForms.Get("OldTest");
                }
                panelMain.Controls.Add(form);
            }
            else if (button == btnIO)
            {
                //CloseWin(panelMain.Controls);
                panelMain.Controls.Clear();
                btnIO.Selected = true;
                BaseForm form;
                //if (ActiveForms.Get("FormIO") == null)
                //{
                //    form = new FormIO();
                //    form.Name = "FormIO";
                //    form.Dock = DockStyle.Fill;
                //    form.TopLevel = false;
                //    form.Visible = true;
                //    ActiveForms.Add(form);
                //}
                //else
                //{
                //    form = ActiveForms.Get("FormIO");
                //}
                form = new FormIO();
                form.Name = "FormIO";
                form.Dock = DockStyle.Fill;
                form.TopLevel = false;
                form.Visible = true;
                //ActiveForms.Add(form);
                panelMain.Controls.Add(form);
            }
            else if(button== btnUpCameraCalibration)
            {
               // CloseWin(panelMain.Controls);
                panelMain.Controls.Clear();
                button.Selected = true;
                BaseForm form;
                form = new UpCameraCalibration();
                form.FormBorderStyle = FormBorderStyle.None;
                form.Name = "UpCameraCalibration";
                form.Dock = DockStyle.Fill;
                form.TopLevel = false;
                form.Visible = true;
                panelMain.Controls.Add(form);
            }
            else if (button == btnDownCameraCalibration)
            {
               //CloseWin(panelMain.Controls);
                panelMain.Controls.Clear();
                button.Selected = true;
                BaseForm form;
                form = new DownCameraCalibration();
                form.FormBorderStyle = FormBorderStyle.None;
                form.Name = "DownCameraCalibration";
                form.Dock = DockStyle.Fill;
                form.TopLevel = false;
                form.Visible = true;
                panelMain.Controls.Add(form);
            }
            else if (button == btnNozzleDistance)
            {
                //CloseWin(panelMain.Controls);
                panelMain.Controls.Clear(); 
                button.Selected = true;
                BaseForm form;
                form = new NozzleDistance();
                form.FormBorderStyle = FormBorderStyle.None;
                form.Name = "NozzleDistance";
                form.Dock = DockStyle.Fill;
                form.TopLevel = false;
                form.Visible = true;
                panelMain.Controls.Add(form);
            }
            else if (button == btnUpCameraAndClampCalibration)
            {
                //CloseWin(panelMain.Controls);
                panelMain.Controls.Clear();
                button.Selected = true;
                BaseForm form;
                form = new UpCameraAndClampCalibration();
                form.FormBorderStyle= FormBorderStyle.None;
                form.Name = "UpCameraAndClampCalibration";
                form.Dock = DockStyle.Fill;
                form.TopLevel = false;
                form.Visible = true;
                panelMain.Controls.Add(form);
            }
            else if (button == btnCommonConfig)
            {
               // CloseWin(panelMain.Controls);
                panelMain.Controls.Clear();
                button.Selected = true;
                BaseForm form;
                form = new CommonConfig();
                form.FormBorderStyle = FormBorderStyle.None;
                form.Name = "CommonConfig";
                form.Dock = DockStyle.Fill;
                form.TopLevel = false;
                form.Visible = true;
                panelMain.Controls.Add(form);
            }
        }

        private void ShowSubForm()
        {




            TableLayoutControlCollection tlcc =  tableLayoutPanel1.Controls;
            foreach (Control c in tlcc)
            {
                if(c is ButtonEx)
                {
                    ((ButtonEx)c).Selected = false;
                }
            }
        }

        private void ConfigForm_Load(object sender, EventArgs e)
        {
            ShowSubForm();
        }
    }
}
