﻿using Rs.Controls;
using Rs.Framework;
using Rs.MotionPlat.Flow;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Rs.MotionPlat.SysConfig
{
    public partial class ClampConfig : BaseForm
    {
        public ClampConfig()
        {
            InitializeComponent();
        }

        private void ClampConfig_Load(object sender, EventArgs e)
        {
            FormIO2 formIO = new FormIO2("龙门");
            formIO.Dock = DockStyle.Fill;
            formIO.Visible = true;
            formIO.TopLevel = false;
            panelEx2.Controls.Add(formIO);
            txtClampCenter2UpCameraCenterX.Text = SysConfigParam.GetValue<string>("ClampCenter2UpCameraCenterX");
            txtClampCenter2UpCameraCenterY.Text = SysConfigParam.GetValue<string>("ClampCenter2UpCameraCenterY");
        }

        private void btnSaveDist_Click(object sender, EventArgs e)
        {
            string ClampCenter2UpCameraCenterX = txtClampCenter2UpCameraCenterX.Text;
            string ClampCenter2UpCameraCenterY = txtClampCenter2UpCameraCenterY.Text;
            SysConfigParam.Update("ClampCenter2UpCameraCenterX", ClampCenter2UpCameraCenterX);
            SysConfigParam.Update("ClampCenter2UpCameraCenterY", ClampCenter2UpCameraCenterY);
            Msg.ShowInfo("Save ok");
        }

        private void btnMoveTakePos_Click(object sender, EventArgs e)
        {
            Button btnMoveTakePos = (Button)sender;
            double centerX = SysConfigParam.GetValue<double>($"{btnMoveTakePos.Tag.ToString()}X");
            double centerY = SysConfigParam.GetValue<double>($"{btnMoveTakePos.Tag.ToString()}Y");

            double cameraCenterX = SysConfigParam.GetValue<double>("ClampCenter2UpCameraCenterX");
            double cameraCenterY = SysConfigParam.GetValue<double>("ClampCenter2UpCameraCenterY");
            Motion.ErrorCode errCode =  AxisControl.LoadX.MovePos(centerX + cameraCenterX,4);
            if(errCode> Motion.ErrorCode.Ok)
            {
                MessageQueue.Instance.Warn($"LoadX axis move ret:{errCode}");
                return;
            }
            errCode = AxisControl.LoadY.MovePos(centerY + cameraCenterY,4);
            if (errCode > Motion.ErrorCode.Ok)
            {
                MessageQueue.Instance.Warn($"LoadY axis move ret:{errCode}");
                return;
            }
        }
    }
}
