﻿using Rs.Controls;
using Rs.DataAccess;
using Rs.Framework;
using Rs.Motion;
using Rs.MotionPlat.Commom;
using Rs.MotionPlat.Flow;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Rs.MotionPlat.SysConfig
{
    public partial class NozzleConfig : BaseForm
    {
        SqliteHelper db = new SqliteHelper();
        public NozzleConfig()
        {
            InitializeComponent();
        }

        private void NozzleConfig_Load(object sender, EventArgs e)
        {
            PositionHelper.BindPosition(groupBox5);
            PositionHelper.BindPosition(groupBox2);
            PositionHelper.BindPosition(groupBox3, "int");
            FormIO2 formIO = new FormIO2("龙门");
            formIO.Dock = DockStyle.Fill;
            formIO.Visible = true;
            formIO.TopLevel = false;
            panelEx2.Controls.Add(formIO);
            int nozzleEanbleValue = SysConfigParam.GetValue<int>("NozzleEnable");
            DataTable dt = db.GetDataTable("select * from nozzle");
            if(dt!=null&&dt.Rows.Count>0)
            {
                foreach (DataRow dataRow in dt.Rows)
                {
                   Control ctl = ControlManager.FindControl(groupBox4, $"cboxNozzle{dataRow["nozzleindex"]}Enable");
                    if(ctl is CheckBox)
                    {
                        CheckBox checkBox = (CheckBox)ctl;
                        checkBox.Checked = dataRow["enable"].ToString() == "1" ? true : false;
                    }
                }
            }
        }

        private void Teach_Click(object sender, EventArgs e)
        {
            PositionHelper.Teach(this, sender);
        }

        private void Stop_Click(object sender, MouseEventArgs e)
        {
            PositionHelper.Stop(sender);
        }
        private void Move_Click(object sender, EventArgs e)
        {
            PositionHelper.Move2This(this,sender);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            for(int i=1;i<10;i++)
            {
                Ops.On($"{i}号吸嘴真空吸电磁阀");
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            for (int i = 1; i < 10; i++)
            {
                Ops.Off($"{i}号吸嘴真空吸电磁阀");
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            for (int i = 1; i < 10; i++)
            {
                Ops.On($"{i}号吸嘴真空破电磁阀");
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            for (int i = 1; i < 10; i++)
            {
                Ops.Off($"{i}号吸嘴真空破电磁阀");
            }
        }


        private void NozzleEnable_CheckedChanged(object sender, EventArgs e)
        {
            string updateSql = "update nozzle set enable={0} where nozzleIndex={1}"; 
            int enable=cboxNozzle1Enable.Checked ? 1 : 0;
            db.ExecuteNonQuery(string.Format(updateSql, enable, 1));

            enable = cboxNozzle2Enable.Checked ? 1 : 0;
            db.ExecuteNonQuery(string.Format(updateSql, enable, 2));

            enable = cboxNozzle3Enable.Checked ? 1 : 0; 
            db.ExecuteNonQuery(string.Format(updateSql, enable, 3));

            enable = cboxNozzle4Enable.Checked ? 1 : 0; 
            db.ExecuteNonQuery(string.Format(updateSql, enable, 4));

            enable = cboxNozzle5Enable.Checked ? 1 : 0; 
            db.ExecuteNonQuery(string.Format(updateSql, enable, 5));

            enable = cboxNozzle6Enable.Checked ? 1 : 0; 
            db.ExecuteNonQuery(string.Format(updateSql, enable, 6));

            enable = cboxNozzle7Enable.Checked ? 1 : 0; 
            db.ExecuteNonQuery(string.Format(updateSql, enable, 7));

            enable = cboxNozzle8Enable.Checked ? 1 : 0; 
            db.ExecuteNonQuery(string.Format(updateSql, enable, 8));

            enable = cboxNozzle9Enable.Checked ? 1 : 0; 
            db.ExecuteNonQuery(string.Format(updateSql, enable, 9));
        }

        private void goHomeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            for(int i=1;i<10;i++)
            {
                AxisControl.GetAxis($"NozzleZ{i}").MovePos(0, GlobalVar.WholeSpeed);
            }
        }

        public void txtSysParam_KeyUp(object sender, KeyEventArgs e)
        {
            UpdateSysParam((TextBox)sender);
        }


        private void MenuItem_Click(object sender, EventArgs e)
        {
            Control ctl = contextMenuStrip2.SourceControl;
            ToolStripMenuItem menuItem = (ToolStripMenuItem)sender;
        }
    }
}
