﻿using Rs.AutoDischarge.V3.Flow;
using Rs.Framework;
using Rs.MotionPlat.Flow;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Rs.MotionPlat.SysConfig
{
    public partial class StockControl : BaseForm
    {
        public StockControl()
        {
            InitializeComponent();
        }

        protected void OnbtnLoadClick(object sender, EventArgs e)
        {
            Button btn = (Button)sender;
            string trayName = btn.Tag.ToString();
            bool ok = Enum.TryParse(trayName, out EStockType result);
            if(ok)
            {
                StockManager.Instance.Load(result);
            }
            
        }

        protected void OnbtnUnLoadClick(object sender, EventArgs e)
        {
            Button btn = (Button)sender;
            string trayName = btn.Tag.ToString();
            bool ok = Enum.TryParse(trayName, out EStockType result);
            if(ok)
            {
                StockManager.Instance.UnLoad(result);
            }
        }

        protected void btnMovetrayClick(object sender, EventArgs e)
        {
            RadioButton rbtnFrom = null;
            RadioButton rbtnTo = null;
            foreach (Control ctl in gboxFrom.Controls)
            {
                if(ctl is RadioButton)
                {
                    rbtnFrom = (RadioButton)ctl;
                    if(rbtnFrom.Checked)
                    {
                        break;
                    }
                }
            }

            foreach (Control ctl in gboxTo.Controls)
            {
                if (ctl is RadioButton)
                {
                    rbtnTo = (RadioButton)ctl;
                    if (rbtnTo.Checked)
                    {
                        break;
                    }
                }
            }

            if(rbtnFrom != null && rbtnTo!=null) {
                if(rbtnFrom.Text == rbtnTo.Text)
                {
                    Msg.ShowError("Cann't move tray to same position");
                    return;
                }

            }
        }

        private void button12_Click(object sender, EventArgs e)
        {
            EStockType fromstock = EStockType.Empty2;
            EStockType tostock = EStockType.Ok ;
            if (btnFromEmpty1.Checked)
                fromstock = EStockType.Empty1;
            if (btnFromInput.Checked)
                fromstock = EStockType.Input;
            if (btnFromOk.Checked)
                fromstock = EStockType.Ok;
            if (btnFromNg.Checked)
                fromstock = EStockType.Ng;
            if (btnFromMulti.Checked)
                fromstock = EStockType.Multi;
            if (btnFromEmpty2.Checked)
                fromstock = EStockType.Empty2;

            if (btnToEmpty1.Checked)
                tostock = EStockType.Empty1;
            if (btnToInput.Checked)
                tostock = EStockType.Input;
            if (btnToOk.Checked)
                tostock = EStockType.Ok;
            if (btnToNg.Checked)
                tostock = EStockType.Ng;
            if (btnToMulti.Checked)
                tostock = EStockType.Multi;
            if (btnToEmpty2.Checked)
                tostock = EStockType.Empty2;
            
            TakeTrayFlow.Instance.Take(fromstock, tostock, ELoadUnloadType.Load);
        }
    }
}
